#include <ode/ode.h>
#include <drawstuff/drawstuff.h>
#include <math.h>
#include <stdlib.h>

#include "parameter.h"

struct Base{       // MyObject\                                                       
  dBodyID body;        // {fB()IDԍi͊wvZpj                                                       
  dGeomID geom;			// WIgIDԍ(ՓˌovZpj                                                   
};

struct Wheel{       // Wheel\                                                       
  dBodyID body;        // {fB()IDԍi͊wvZpj                                                       
  dGeomID geom;			// WIgIDԍ(ՓˌovZpj    

};

struct IrSensor{       // IrSensor\                                                       
	dGeomID ray;        // rayIDԍi͊wvZpj                                                       
	dVector3 start_pos;
	dVector3 end_pos;
	dVector3 collide_pos[COLLIDE_MAX];
	int collide_cnt;
	int collide_num;
	bool collide_flag;
	dReal ray_ang;
	int value;
};

struct Epuck{       // Epuck\                                                       
	Base base,base1,base2;
	dJointID Base_joint,Base2_joint;
	Wheel wheel[WHEEL_MAX];
	dJointID joint[WHEEL_MAX]; 
	IrSensor ir_sensor[SUB_SENSOR_MAX];
	bool collide_flag;
	dReal leftwheelspeed;
	dReal rightwheelspeed;
	const dReal *pos;
};

struct Agent{       // Agent\ 
	bool	goal_flag;
	double	output_sum;
	int		SUBGOAL_FLAG[SUBGOAL];
	int		ENV_FIT[REPEAT_MAX];
	int		FITNESS;
	int		SUCCESS;
	double	INPUT_NEU[IN_NEU];
	double	OUTPUT_NEU[OUT_NEU];
	double	NEU[N_MAX][DIM_N];
	double	NEU_1[N_MAX][DIM_N];
	double  SYN[SYN_MAX][DIM_S];
	double  SYN_1[SYN_MAX][DIM_S];
};

struct Environment{       // Environment\                                                       
	dBodyID body;        // {fB()IDԍi͊wvZpj                                                       
	dGeomID geom;			// WIgIDԍ(ՓˌovZpj               
	dJointID wall_floor_joint;
	dReal wall_pos[3];
	dReal wall_size[3];
};

extern dWorldID world;  // ͊wvZp[h
extern dSpaceID space;  // ՓˌopXy[X                                                   
extern dGeomID  ground; // n  
extern dJointGroupID contactgroup;     
extern dsFunctions fn;

extern struct Epuck EPUCK;

extern struct Environment ENVIRONMENT[WALL_MAX];

extern int SIM_STEP;

/************************ga***********************************/
extern struct Agent AGENT[FAM_MAX];
extern int CNT_REPEAT;
extern int CNT_FAMILY;
extern int CNT_GENERATION;
extern int CNT_TRIAL;

extern int ELI_FIT[ELI_MAX];
extern int ELI[ELI_MAX];

extern int CNT_FALSE;
extern int CNT_SUCCESS;
extern double RESULT[TRIAL_MAX+1][GEN_MAX+1][5];
extern int SEED[TRIAL_MAX];
extern int SEED_TRIAL;

