
// select correct drawing functions
#ifdef dDOUBLE
#define dsDrawBox      dsDrawBoxD
#define dsDrawSphere   dsDrawSphereD
#define dsDrawCapsule  dsDrawCapsuleD 
#define dsDrawCylinder dsDrawCylinderD
#define dsDrawLine     dsDrawLineD
#endif

#define PI acos(-1.0)

//#define DRAW	false
#define DRAW	true

/******************** sim parameter ***********************/
#define seed 165811 /*̎*/

#define STEP_MAX  20000	/*JԂXebv x 0.01[s]*/

#define S_VALUE 10		/*]l*/

#define SUBGOAL 60		/*TuS[*/

/******************** e-puck model ***********************/
#define BASE_M1	0.16		// Ԃ̎ x100[g]
#define BASE_M2	0.27		// Ԃ̎ x100[g]
#define BASE_M3	1.07        // Ԃ̎ x100[g]

#define BASE_r	0.33        // Ԃ̔a x100[mm]
#define BASE_r1 0.333
#define BASE_r2 0.14

#define BASE_l	0.36		// Ԃ̍ x100[mm]
#define BASE_l1	0.11		// Ԃ̍ x100[mm]
#define BASE_l2	0.06		// Ԃ̍ x100[mm]


#define WHEEL_MAX 2		// ԗւ̌
#define	WH_R	0.205	// ԗ0,1̔a x100[mm]
#define	WH_W	0.02	// ԗւ̕ x100[mm]
#define	WH_M	0.1		// ԗւ̎ x100[g]
#define WHEEL_SPEED 0.8	// ԗւ̍ő]x x2PI[rad/sec]

#define SENSOR_MAX 8					//ZŤ
#define SUB_SENSOR_MAX 24				//ZŤ
#define SENSOR_VALUE_MAX 4000.0
#define SEN_R	1.0						//ZT͈ x100[cm]
#define RAY_START_R 0.3302//0.3605	    //ԊO̎n_ x100[cm]
#define RAY_END_R (RAY_START_R+SEN_R)	//ԊȌI_ x100[cm]
#define SENSOR_NOISE_RANGE 0.005
#define SENSOR_Z (0.33-BASE_l/2)
#define DRIVE_NOISE_RANGE 0.15

#define START_X	 PASSAGE_WIDTH/2		// ʒux x100[mm]
#define START_Y  PASSAGE_WIDTH/2-0.2	// ʒuy x100[mm]
#define START_Z  0.18					    // ʒuz x100[mm]

#define START_X1 PASSAGE_WIDTH/2		// ʒux x100[mm]
#define START_Y1 PASSAGE_WIDTH/2-0.2	// ʒuy x100[mm]
#define START_Z1 0.18					    // ʒuz x100[mm]

#define START_X2 PASSAGE_WIDTH/2//-0.2		// ʒux x100[mm]
#define START_Y2 PASSAGE_WIDTH/2-0.3//0.0   // ʒuy x100[mm]
#define START_Z2 0.18					    // ʒuz x100[mm]

#define TRANS_PERIOD 10				    //ʐM x0.01[s]

/*******************ԊO̐ݒupx********************/
//ZTpx0
#define Ray1_Ang 18		//ԊO1̐ݒupx
#define Ray2_Ang 50		//ԊO2̐ݒupx
#define Ray3_Ang 90.1	//ԊO3̐ݒupx
#define Ray4_Ang 150	//ԊO4̐ݒupx
#define Ray5_Ang 210	//ԊO5̐ݒupx
#define Ray6_Ang 270.01	//ԊO6̐ݒupx
#define Ray7_Ang 310	//ԊO7̐ݒupx
#define Ray8_Ang 342	//ԊO8̐ݒupx

//ZTpx}8.0
#define Ray9_Ang  10	//ԊO09̐ݒupx	
#define Ray10_Ang 26.0	//ԊO10̐ݒupx	
#define Ray11_Ang 42.0	//ԊO11̐ݒupx	
#define Ray12_Ang 58.0	//ԊO12̐ݒupx	
#define Ray13_Ang 82.0	//ԊO13̐ݒupx
#define Ray14_Ang 98.0	//ԊO14̐ݒupx
#define Ray15_Ang 142.0	//ԊO15̐ݒupx
#define Ray16_Ang 158.0	//ԊO16̐ݒupx
#define Ray17_Ang 202.0	//ԊO17̐ݒupx
#define Ray18_Ang 218.0	//ԊO18̐ݒupx
#define Ray19_Ang 262.3	//ԊO19̐ݒupx
#define Ray20_Ang 278.01//ԊO20̐ݒupx
#define Ray21_Ang 302.0	//ԊO21̐ݒupx
#define Ray22_Ang 318.0	//ԊO22̐ݒupx
#define Ray23_Ang 334.0	//ԊO23̐ݒupx
#define Ray24_Ang 350.0	//ԊO24̐ݒupx

/******************** environment model ***********************/
#define WALL_MAX 16					//ǂ̌(l16)
#define WALL_JOINT_MAX (WALL_MAX)	//ǂƏ̃WCg=WALL_MAX
#define PASSAGE_WIDTH 1.52f			//ʘH̕ x100[mm]
#define WALL_POS_Z 0.251			//ǂ̏ʒuz x100[mm]

/************************** ODE ******************************/
#define COLLIDE_MAX 200				//Փˌo
