#include <ode/ode.h>
#include <drawstuff/drawstuff.h>
#include <math.h>
#include <stdlib.h>

#include "Parameter.h"

static void command(int cmd);

struct Base{       // MyObject\                                                       
  dBodyID body;        // {fB()IDԍi͊wvZpj                                                       
  dGeomID geom;			// WIgIDԍ(ՓˌovZpj                                                   
};

struct Wheel{       // Wheel\                                                       
  dBodyID body;        // {fB()IDԍi͊wvZpj                                                       
  dGeomID geom;			// WIgIDԍ(ՓˌovZpj    

};

struct IrSensor{       // IrSensor\                                                       
	dGeomID ray;        // rayIDԍi͊wvZpj                                                       
	dVector3 start_pos;
	dVector3 end_pos;
	dVector3 collide_pos[COLLIDE_MAX];
	int collide_cnt;
	int collide_num;
	bool collide_flag;
	dReal ray_ang;
	int value;
};

struct Epuck{       // Epuck\                                                       
	Base base,base1,base2;
	dJointID Base_joint,Base2_joint;
	Wheel wheel[WHEEL_MAX];
	dJointID joint[WHEEL_MAX]; 
	IrSensor ir_sensor[SUB_SENSOR_MAX];
	bool collide_flag;
	dReal leftwheelspeed;
	dReal rightwheelspeed;
	const dReal *pos;
};

struct Agent{       // Agent\ 
	bool	goal_flag;
	bool	end_flag;
	bool	left_wall_flag;
	double	output_sum;
	int	E_value;
	int	SUBGOAL_FLAG[SUBGOAL];
};

struct Environment{       // Environment\                                                       
	dBodyID body;        // {fB()IDԍi͊wvZpj                                                       
	dGeomID geom;			// WIgIDԍ(ՓˌovZpj               
	dJointID wall_floor_joint;
	dReal wall_pos[3];
	dReal wall_size[3];
};

extern dWorldID world;  // ͊wvZp[h
extern dSpaceID space;  // ՓˌopXy[X                                                   
extern dGeomID  ground; // n  
extern dJointGroupID contactgroup;     
extern dsFunctions fn;

extern struct Epuck EPUCK;

extern struct Agent AGENT;

extern struct Environment ENVIRONMENT[WALL_MAX];

extern int SIM_STEP;

