
// select correct drawing functions
#ifdef dDOUBLE
#define dsDrawBox      dsDrawBoxD
#define dsDrawSphere   dsDrawSphereD
#define dsDrawCapsule  dsDrawCapsuleD 
#define dsDrawCylinder dsDrawCylinderD
#define dsDrawLine     dsDrawLineD
#endif

#define PI acos(-1.0)

#define seed 5811 /*̎*/

/*************************************************************/
//#define DRAW	false	/*`Ȃ*/
#define DRAW	true	/*`悠*/

#define LOAD true		/*true:ʂ̐U镑mF*/
//#define LOAD false		/*VK*/

/*************************GAp[^*************************/
#define TRIAL_MAX 4		/*s*/
#define REPEAT_MAX 3	/*1̂̑s*/
#define STEP_MAX  24000	/*JԂXebv x 0.01[s]*/

#define GEN_MAX 50		/*K萢㐔*/
#define FAM_MAX 30		/*Wc̑傫*/
#define ELI_MAX  3		/*G[gۑ̐*/
#define NEW_MAX 2		/*VKQ̐*/

#define MUTATION_RATE 0.05	 /*ˑRψيmi0`1j*/
#define CROSSOVER_RATE 0.80		/*mi0`1j*/

#define S_VALUE 10		/*Kx̏l*/
#define OUT_WEIGHT 1.0	/*]lɂԗււ̏o͒lɑ΂d*/
#define DIV_WEIGHT 0.0	/*ꂼ̑sɂ]l̂΂ɑ΂d*/

#define SAMPLE_DIS_MIN_INI 3.70 /*̂ѐ㎞̐VKQ̂𐶐ۂ̌̊Ԃ̍ŏ[Nbh*/
#define SETUP_ITE 200	/*̂𐶐ۂ̎s̏izꍇCŏ蒼j*/
#define SUBGOAL 60		/*TuS[̍ő吔i{IɕύXKvȂj*/

/******************* NNp[^ *********************/
#define OUT_NEU 2 /*o͑w̃j[*/
#define IN_NEU (SENSOR_MAX+2) /*͑w̃j[*/
#define H_NEURON 6 /*ԑw̃j[*/
#define N_MAX  ((int)IN_NEU+(int)OUT_NEU+(int)H_NEURON) /*j[*/
#define SYN_MAX 72 /*VivX*/

#define S_WEIGHT_MI -5.0 /* ׏d̍ŏliœKΏہj*/
#define S_WEIGHT_MA 5.0 /* ׏d̍őliœKΏہj*/

#define SITA_MI 0.0 /*VOCh֐̂l̍ŏli͍œK̑ΏۊOj*/
#define SITA_MA 0.0 /*VOCh֐̂l̍őli͍œK̑ΏۊOj*/
#define BETA_MI 1.00 /*VOCh֐̗オl̍ŏli͍œK̑ΏۊOj*/
#define BETA_MA 1.00 /*VOCh֐̗オl̍őli͍œK̑ΏۊOj*/

#define DIM_N 4 /*j[̕ϐ̌i{IɕύXKvȂj*/
#define DIM_S 3 /*VivX̕ϐ̌i{IɕύXKvȂj*/

#define A_Y 0 /*j[̏o͒l̔zԍi{IɕύXKvȂj*/
#define A_X 1 /*j[̓͒l̔zԍi{IɕύXKvȂj*/
#define A_SITA 2 /*j[臒l̔zԍi{IɕύXKvȂj*/
#define A_BETA 3 /*j[̃VOCh֐̃̔zԍi{IɕύXKvȂj*/

#define W_0 0 /*VivX̌׏d̔zԍi{IɕύXKvȂj*/
#define POS_N_I 1 /*VivX̃VivXj[̔zԍi{IɕύXKvȂj*/
#define PRE_N_J 2 /*VivX̃VivXOj[̔zԍi{IɕύXKvȂj*/

/******************** e-puck model ***********************/
#define BASE_M1	0.16		// Ԃ̎ x100[g]
#define BASE_M2	0.27		// Ԃ̎ x100[g]
#define BASE_M3	1.07        // Ԃ̎ x100[g]

#define BASE_r	0.33        // Ԃ̔a x10[cm]
#define BASE_r1 0.333		// Ԃ̔a x10[cm]
#define BASE_r2 0.14		// Ԃ̔a x10[cm]

#define BASE_l	0.36		// Ԃ̍ x10[cm]
#define BASE_l1	0.11		// Ԃ̍ x10[cm]
#define BASE_l2	0.06		// Ԃ̍ x10[cm]


#define WHEEL_MAX 2						// ԗւ̌
#define	WH_R	0.205					// ԗ0,1̔a x10[cm]
#define	WH_W	0.02//0.03				// ԗւ̕ x10[cm]
#define	WH_M	0.1						// ԗւ̎ x100[g]
#define WHEEL_SPEED 0.8					// ԗւ̍ő]x x2PI[rad/sec]

#define SENSOR_MAX 8					//ZŤ
#define SUB_SENSOR_MAX 24				//ZŤ
#define SENSOR_VALUE_MAX 4000.0
#define SEN_R	1.0						//ZT͈ x10[cm]
#define RAY_START_R 0.3302//0.3605	    //ԊO̎n_ x10[cm]
#define RAY_END_R (RAY_START_R+SEN_R)	//ԊȌI_ x10[cm]
#define SENSOR_NOISE_RANGE 0.005		//ZTl̃mCY͈
#define SENSOR_Z (0.33-BASE_l/2)		//ZT̎t
#define DRIVE_NOISE_RANGE 0.15			//CW̃mCY͈

#define START_X	 PASSAGE_WIDTH/2//-0.2		// ʒux x10[cm]
#define START_Y  PASSAGE_WIDTH/2-0.2//0.0	// ʒuy x10[cm]
#define START_Z  0.18					    // ʒuz x10[cm]

#define START_X1 PASSAGE_WIDTH/2//-0.2		// ʒux x10[cm]
#define START_Y1 PASSAGE_WIDTH/2-0.2//0.0	// ʒuy x10[cm]
#define START_Z1 0.18					    // ʒuz x10[cm]

#define START_X2 PASSAGE_WIDTH/2//-0.2		// ʒux x10[cm]
#define START_Y2 PASSAGE_WIDTH/2-0.3//0.0   // ʒuy x10[cm]
#define START_Z2 0.18					    // ʒuz x10[cm]

#define TRANS_PERIOD 10//25				    //ʐM x10[msec]

/*******************ԊO̐ݒupx********************/
//ZTpx0
#define Ray1_Ang 18		//ԊO1̐ݒupx
#define Ray2_Ang 50		//ԊO2̐ݒupx
#define Ray3_Ang 90.1	//ԊO3̐ݒupx
#define Ray4_Ang 150	//ԊO4̐ݒupx
#define Ray5_Ang 210	//ԊO5̐ݒupx
#define Ray6_Ang 270.01	//ԊO6̐ݒupx
#define Ray7_Ang 310	//ԊO7̐ݒupx
#define Ray8_Ang 342	//ԊO8̐ݒupx

//ZTpx}8.0
#define Ray9_Ang  10	//ԊO09̐ݒupx18	
#define Ray10_Ang 26.0	//ԊO10̐ݒupx18	
#define Ray11_Ang 42.0	//ԊO11̐ݒupx50	
#define Ray12_Ang 58.0	//ԊO12̐ݒupx50	
#define Ray13_Ang 82.0	 //ԊO13̐ݒupx90.1
#define Ray14_Ang 98.0	//ԊO14̐ݒupx90.1
#define Ray15_Ang 142.0	//ԊO15̐ݒupx150
#define Ray16_Ang 158.0	//ԊO16̐ݒupx150
#define Ray17_Ang 202.0	//ԊO17̐ݒupx210
#define Ray18_Ang 218.0	//ԊO18̐ݒupx210
#define Ray19_Ang 262.3	//ԊO19̐ݒupx270.01
#define Ray20_Ang 278.01	//ԊO20̐ݒupx270.01
#define Ray21_Ang 302.0	//ԊO21̐ݒupx310
#define Ray22_Ang 318.0	//ԊO22̐ݒupx310
#define Ray23_Ang 334.0	//ԊO23̐ݒupx342
#define Ray24_Ang 350.0	//ԊO24̐ݒupx342

/******************** environment model ***********************/
#define WALL_MAX 16					//ǂ̌(l16)
#define WALL_JOINSTEP_MAX (WALL_MAX)	//ǂƏ̃WCg=WALL_MAX
#define PASSAGE_WIDTH 1.52f			//ʘH̕ x10[cm]
#define WALL_POS_Z 0.251			//ǂ̏ʒuz x10[cm]

/************************** ODE ******************************/
#define COLLIDE_MAX 200				//Փˌo
